## snobol4-1.3.tar.gz

=== Makefile ===
# $Id: Makefile,v 1.72 2010/05/19 16:07:42 phil Exp $

# TARGETS:
#
# snobol4	make xsnobol4 binary; regression test; link to snobol4
# xsnobol4	make xsnobol4 binary; no regression test
#
# tidy		remove turds (backup, temp files)
# cleanmostly	removes objects, turds; leave generated sources, final binary
# clean		clean as when unpacked (removes binary)
# spotless	removes snobol4 generated files (requires binary to regenerate)
#
# tar		make distribution
# uu		make uuencoded distribution

# m4 macro processor; used to generate Makefile2
# (largely to avoid depending on make '+=' operator)
M4=m4

################
# snobol commands

# bootstrapped using Catspaw SPARC SPITBOL
#SNO=spitbol -i512k -b
SNO=snobol4 -b

################
# machine generated files (final products);

GENERATED=data.c data_init.h proc.h static.h syn.h data.h \
	equ.h res.h syn.c syn_init.h isnobol4.c snobol4.c host.sno

################
# SIL source file
SIL=	v311.sil

################
# AIX4 makes all targets, so added this;
# must be named "all" for FreeBSD "ports"?

all:	snobol4

# force GNU make to run top Makefile serially
.NOTPARALLEL: foo

# tell BSD make to use a single shell
.SINGLESHELL: foo

# files to avoid removing when interrupted
.PRECIOUS: snobol4 xsnobol4 Makefile2 $(GENERATED)

snobol4 xsnobol4 install lint: $(GENERATED) Makefile2 ALWAYS .depend
	$(MAKE) -f Makefile2 $@

# a rule depending on this target will always be run
# since ALWAYS is never created!
ALWAYS:

# for hand generation of sources
generated: $(GENERATED)

################
# run configuration script

config.m4 config.h: configure
	./configure

################
# make second level makefile

M2TMP=Makefile2.tmp
Makefile2 .depend: config.m4 Makefile2.m4
	echo '# DO NOT EDIT. machine generated from Makefile2.m4' > $(M2TMP)
	echo '# add local changes to local-config'		>> $(M2TMP)
	$(M4) Makefile2.m4 >> $(M2TMP)
	echo '# DO NOT DELETE THIS LINE. make depend uses it.' >> $(M2TMP)
	$(MAKE) -f $(M2TMP) depend MAKEFILE2=$(M2TMP)
	mv -f $(M2TMP) Makefile2
	rm -f .depend
	touch .depend

################
# code

# regular version
snobol4.c proc.h2 static.h2: procs genc.sno globals $(SIL) 
	rm -f snobol4.c2 proc.h2 static.h2
	$(SNO) genc.sno $(SIL) > snobol4.c2
	mv -f snobol4.c2 snobol4.c

# generate inline version (functions reordered)

# Uses tsort (topological sort), to order routines for best inlining.
# private copy of FreeBSD version of tsort (topological sort) supplied
# since GNU version used on Linux and Cygwin can't handle cycles

# isnobol4.c can't depend on bsdtsort, since that would force
# isnobol4.c to be rebuilt (which requires a snobol4 binary) when
# starting with a distribution kit.  Using a SNOBOL4 tsort.sno program
# would solve the problem, but I've yet to write one that works as
# well as the C version.

isnobol4.c: procs genc.sno globals $(SIL)
	rm -rf isnobol4.c2 proc.h2 static.h2 prolog subr
	test -f bsdtsort || $(CC) -o bsdtsort bsdtsort.c
	mkdir subr
	$(SNO) -- genc.sno --inline $(SIL) > prolog
	cd subr && ../bsdtsort < ../callgraph > order && \
		cat ../prolog `cat order` > ../isnobol4.c2
	mv -f isnobol4.c2 isnobol4.c
	rm -rf prolog subr

proc.h:	proc.h2
	@cmp proc.h proc.h2 || cp proc.h2 proc.h

static.h: static.h2
	@cmp static.h static.h2 || cp static.h2 static.h

################
# syntax tables

# only change syn.h if it has changed from last run!

syn.c syn.h2 syn_init.h2: syntax.tbl gensyn.sno
	rm -f syn.c2 syn.h2
	$(SNO) gensyn.sno syntax.tbl
	mv -f syn.c2 syn.c

syn.h:	syn.h2
	@cmp syn.h syn.h2 || cp syn.h2 syn.h

syn_init.h: syn_init.h2
	@cmp syn_init.h syn_init.h2 || cp syn_init.h2 syn_init.h

################
# resident data

data.h2 data.c2 equ.h2 data_init.h2 res.h2: $(SIL) gendata.sno
	rm -f data.h2 data.c2 equ.h2 data_init.h2 res.h2
	$(SNO) gendata.sno $(SIL)

data.h:	data.h2
	@cmp data.h data.h2 || cp data.h2 data.h

data.c:	data.c2
	@cmp data.c data.c2 || cp data.c2 data.c

equ.h:	equ.h2
	@cmp equ.h equ.h2 || cp equ.h2 equ.h

res.h:	res.h2
	@cmp res.h res.h2 || cp res.h2 res.h

data_init.h: data_init.h2
	@cmp data_init.h data_init.h2 || cp data_init.h2 data_init.h

#################
# generated snolib files

host.sno: host.awk lib/snolib/host.h
	awk -f host.awk lib/snolib/host.h > host.sno

#################
# dependency generation is slow and ugly (and wrong?)
# doesn't change much!!

#procs:	gendep.sno
#	$(SNO) gendep.sno < $(SIL) > procs2
#	mv -f procs2 procs

##################################################################
# housekeeping

# directly generated files (to avoid recompilation when no change in outputs)
G2=data.c2 data.h2 data_init.h2 proc.h2 static.h2 equ.h2 \
	syn.h2 syn_init.h2 res.h2

# remove turds
tidy:
	rm -rf subr
	cd test; sh clean.sh
	find . -type f -a \( \
		-name '*~' -o -name '#*' -o -name '*.tmp' -o -name '.#*' \) \
		-print | xargs -t rm -f

# disposables
DISP=*.o *.a callgraph prolog bsplitu pv vers build.c bsdtsort \
	config.m4 config.h Makefile2 .depend cpuid

# Inspired by PowderMilk bisquits
# (made by Norwegian Bachelor farmers, so you know they're pure, mostly);
# remove objects, turds; leave generated sources, final binary.
cleanmostly: tidy
	rm -f $(DISP)
	rm -rf timdir.*

# clean as a freshly unpacked kit; remove binaries, timing file
clean:	cleanmostly
	rm -f snobol4 xsnobol4 timing.out *.ln

# DANGER: requires installed binary to rebuild!!
# remove objects, generated files (clean as a fresh CVS checkout)
spotless: clean
	rm -f $(GENERATED) $(G2) snobol4.c isnobol4.c snobol4 xsnobol4

# "print version" -- for dir/tar names
pv:	version.c
	$(CC) -I./include -DMAIN -o pv version.c

=== doc/Makefile ===
# Makefile for doc files
# $Id: Makefile,v 1.12 2005/12/07 02:04:52 phil Exp $

ALL=	porting.txt \
	snobol4.0 snobol4.html snobol4.ps snobol4.pdf \
	snolib.0 snolib.html snolib.ps snolib.pdf \
	snobol4dbm.0 snobol4dbm.html snobol4dbm.ps snobol4dbm.pdf \
	snobol4tcl.0 snobol4tcl.html snobol4tcl.ps snobol4tcl.pdf

all:	$(ALL)

PORTING=porting.html porting.ps
porting: $(PORTING)

MS=-ms
MAN=-man

# Use groff; does bolding!!
NROFF=groff -Tascii

# troff to PostScript
TROFF_PS=groff -Tps

# troff to HTML
TROFF_HTML=groff -Thtml

####

porting.txt: porting.ms Makefile
	$(NROFF) $(MS) porting.ms > porting.txt

porting.html: porting.ms Makefile
	$(TROFF_HTML) $(MS) porting.ms > porting.html

porting.ps: porting.ms Makefile
	$(TROFF_PS) $(MS) porting.ms > porting.ps

####

snobol4.0: snobol4.1 Makefile
	$(NROFF) $(MAN) snobol4.1 > snobol4.0

snobol4.html: snobol4.1 Makefile
	$(TROFF_HTML) $(MAN) snobol4.1 > snobol4.html

snobol4.ps: snobol4.1 Makefile
	$(TROFF_PS) $(MAN) snobol4.1 > snobol4.ps

snobol4.pdf: snobol4.ps
	ps2pdf snobol4.ps snobol4.pdf

####

snolib.0: snolib.3 Makefile
	$(NROFF) $(MAN) snolib.3 > snolib.0

snolib.html: snolib.3 Makefile
	$(TROFF_HTML) $(MAN) snolib.3 > snolib.html

snolib.ps: snolib.3 Makefile
	$(TROFF_PS) $(MAN) snolib.3 > snolib.ps

snolib.pdf: snolib.ps
	ps2pdf snolib.ps snolib.pdf

####

snobol4dbm.0: snobol4dbm.3 Makefile
	$(NROFF) $(MAN) snobol4dbm.3 > snobol4dbm.0

snobol4dbm.html: snobol4dbm.3 Makefile
	$(TROFF_HTML) $(MAN) snobol4dbm.3 > snobol4dbm.html

snobol4dbm.ps: snobol4dbm.3 Makefile
	$(TROFF_PS) $(MAN) snobol4dbm.3 > snobol4dbm.ps

snobol4dbm.pdf: snobol4dbm.ps
	ps2pdf snobol4dbm.ps snobol4dbm.pdf

####

snobol4tcl.0: snobol4tcl.3 Makefile
	$(NROFF) $(MAN) snobol4tcl.3 > snobol4tcl.0

snobol4tcl.html: snobol4tcl.3 Makefile
	$(TROFF_HTML) $(MAN) snobol4tcl.3 > snobol4tcl.html

snobol4tcl.ps: snobol4tcl.3 Makefile
	$(TROFF_PS) $(MAN) snobol4tcl.3 > snobol4tcl.ps

snobol4tcl.pdf: snobol4tcl.ps
	ps2pdf snobol4tcl.ps snobol4tcl.pdf

################

clean:
	rm -f $(ALL) $(PORTING)

=== config/djgpp/Makefile ===
# $Id: Makefile,v 1.15 2005/12/05 06:43:46 phil Exp $

# make file for DJGPP - P. Budne 2/16/2002
# from make file for MINGW - P. Budne 2/14/2002
# and batch files by Burkhard Meissner
# from nmake file for VC++ 5.0 on WinNT 4.0 P. Budne 2/4/1998
# from batch file by David Feustel

CC=gcc
OPT=-O3

# defaults
INET_C=$(SRCDIR)lib/dummy/inet.c
LOAD_C=$(SRCDIR)lib/dummy/load.c

# DXE2 LOAD() support.  DXE2 available from "v2tk" directory
# on DJGPP distribution mirror sites.  Unpack and run "make install"
#
# uncomment next 4 lines to enable;
#DXE_DEFS=-DHAVE_DXE2
#LOAD_C=$(SRCDIR)lib/unix98/load.c
#DXE_OBJS=osinit.o
#DXE_LIBS=-ldl
#
# "DXE3" now part of DJGPP distribution (as of April 2003)
#	Didn't find it in a basic install of v2 -phil
#

# TCP/IP support, using WATTCP (see www.wattcp.com)
#
# edit as needed for your installation;
WATTCP_DIR=/djgpp/wattcp
WATTCP_INCDIR=${WATTCP_DIR}/inc
WATTCP_LIBDIR=${WATTCP_DIR}/lib
#
# uncomment next 4 lines to enable;
#WATTCP_DEFS=-I${WATTCP_INCDIR} -DHAVE_WATTCP
#INET_C=$(SRCDIR)lib/bsd/inet.c
#INET_OBJS=bindresvport.o
#WATTCP_LIBS=-L${WATTCP_LIBDIR} -lwatt

# Ozan Yigit's SDBM routines for NDBM interface
SDBM_DEFS=-DPML_NDBM -DHAVE_SDBM_H -DDUFF -Ilib/sdbm
SDBM_OBJS=ndbm.o sdbm_pair.o sdbm_hash.o sdbm.o

CFLAGS=	-c $(OPT) -I$(SRCDIR)config/djgpp -I$(SRCDIR)include -I$(SRCDIR). \
	-DHAVE_CONFIG_H $(WATTCP_DEFS) $(DXE_DEFS) $(SDBM_DEFS)

# WATTCP must be first!
LIBS=$(WATTCP_LIBS) -lm -lc -lpc $(DXE_LIBS) 

OBJ=	isnobol4.o data.o data_init.o main.o syn.o \
	version.o bal.o date.o dump.o endex.o hash.o \
	intspc.o io.o lexcmp.o ordvst.o pair.o pat.o \
	pml.o realst.o replace.o str.o stream.o top.o \
	tree.o bcopy.o bzero.o dynamic.o expops.o getopt.o \
	init.o load.o mstime.o chop.o cos.o delete.o \
	exit.o exp.o file.o getstring.o handle.o \
	host.o log.o logic.o ord.o rename.o retstring.o sin.o \
	spcint.o spreal.o sprintf.o sqrt.o sset.o \
	tan.o sys.o tty.o inet.o execute.o exists.o \
	term.o findunit.o $(DXE_OBJS) $(INET_OBJS) $(SDBM_OBJS)

snobol4.exe: $(OBJ)
	$(CC) -o snobol4 $(OBJ) $(LIBS)

data.o:	$(SRCDIR)data.c
	$(CC) $(CFLAGS) $(SRCDIR)data.c

data_init.o: $(SRCDIR)data_init.c
	$(CC) $(CFLAGS) $(SRCDIR)data_init.c

isnobol4.o: $(SRCDIR)isnobol4.c
	$(CC) $(CFLAGS) $(SRCDIR)isnobol4.c

main.o:	$(SRCDIR)main.c
	$(CC) $(CFLAGS) $(SRCDIR)main.c

syn.o:	$(SRCDIR)syn.c
	$(CC) $(CFLAGS) $(SRCDIR)syn.c

version.o: $(SRCDIR)version.c
	$(CC) $(CFLAGS) $(SRCDIR)version.c

################ common

bal.o:	$(SRCDIR)lib/bal.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/bal.c

date.o:	$(SRCDIR)lib/date.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/date.c

dump.o:	$(SRCDIR)lib/dump.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/dump.c

endex.o: $(SRCDIR)lib/endex.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/endex.c

hash.o:	$(SRCDIR)lib/hash.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/hash.c

init.o:	$(SRCDIR)lib/init.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/init.c

io.o:	$(SRCDIR)lib/io.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/io.c

lexcmp.o: $(SRCDIR)lib/lexcmp.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/lexcmp.c

ordvst.o: $(SRCDIR)lib/ordvst.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/ordvst.c

pair.o:	$(SRCDIR)lib/pair.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/pair.c

pat.o:	$(SRCDIR)lib/pat.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/pat.c

pml.o:	$(SRCDIR)lib/pml.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/pml.c

realst.o: $(SRCDIR)lib/realst.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/realst.c

replace.o: $(SRCDIR)lib/replace.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/replace.c

str.o:	$(SRCDIR)lib/str.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/str.c

stream.o: $(SRCDIR)lib/stream.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/stream.c

top.o:	$(SRCDIR)lib/top.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/top.c

tree.o:	$(SRCDIR)lib/tree.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/tree.c

################ ansi

spcint.o: $(SRCDIR)lib/ansi/spcint.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/ansi/spcint.c

spreal.o: $(SRCDIR)lib/ansi/spreal.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/ansi/spreal.c

################ auxil

bcopy.o: $(SRCDIR)lib/auxil/bcopy.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/auxil/bcopy.c

bzero.o: $(SRCDIR)lib/auxil/bzero.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/auxil/bzero.c

getopt.o: $(SRCDIR)lib/auxil/getopt.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/auxil/getopt.c

bindresvport.o: $(SRCDIR)lib/auxil/bindresvport.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/auxil/bindresvport.c

################ dummy

execute.o: $(SRCDIR)lib/dummy/execute.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/dummy/execute.c

################ generic

dynamic.o: $(SRCDIR)lib/generic/dynamic.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/generic/dynamic.c

expops.o: $(SRCDIR)lib/generic/expops.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/generic/expops.c

intspc.o: $(SRCDIR)lib/generic/intspc.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/generic/intspc.c

################ posix!

term.o:	$(SRCDIR)lib/posix/term.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/posix/term.c

mstime.o: $(SRCDIR)lib/posix/mstime.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/posix/mstime.c

tty.o:	$(SRCDIR)lib/posix/tty.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/posix/tty.c

################ misc

# bsd or dummy
inet.o:	$(INET_C)
	$(CC) $(CFLAGS) $(INET_C)

# unix98 or dummy
load.o:	$(LOAD_C)
	$(CC) $(CFLAGS) $(LOAD_C)

################ generic

exists.o: $(SRCDIR)lib/generic/exists.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/generic/exists.c

################ snolib

chop.o:	$(SRCDIR)lib/snolib/chop.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/chop.c

cos.o:	$(SRCDIR)lib/snolib/cos.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/cos.c

delete.o: $(SRCDIR)lib/snolib/delete.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/delete.c

exit.o:	$(SRCDIR)lib/snolib/exit.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/exit.c

exp.o:	$(SRCDIR)lib/snolib/exp.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/exp.c

file.o:	$(SRCDIR)lib/snolib/file.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/file.c

findunit.o: $(SRCDIR)lib/snolib/findunit.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/findunit.c

getstring.o: $(SRCDIR)lib/snolib/getstring.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/getstring.c

handle.o: $(SRCDIR)lib/snolib/handle.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/handle.c

host.o:	$(SRCDIR)lib/snolib/host.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/host.c

log.o:	$(SRCDIR)lib/snolib/log.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/log.c

logic.o: $(SRCDIR)lib/snolib/logic.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/logic.c

ndbm.o: $(SRCDIR)lib/snolib/ndbm.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/ndbm.c

ord.o:	$(SRCDIR)lib/snolib/ord.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/ord.c

rename.o: $(SRCDIR)lib/snolib/rename.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/rename.c

retstring.o: $(SRCDIR)lib/snolib/retstring.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/retstring.c

sin.o:	$(SRCDIR)lib/snolib/sin.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/sin.c

sprintf.o: $(SRCDIR)lib/snolib/sprintf.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/sprintf.c

sqrt.o:	$(SRCDIR)lib/snolib/sqrt.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/sqrt.c

sset.o:	$(SRCDIR)lib/snolib/sset.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/sset.c

tan.o:	$(SRCDIR)lib/snolib/tan.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/snolib/tan.c

#### sdbm

sdbm.o: $(SRCDIR)lib/sdbm/sdbm.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/sdbm/sdbm.c

sdbm_pair.o: $(SRCDIR)lib/sdbm/sdbm_pair.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/sdbm/sdbm_pair.c

sdbm_hash.o: $(SRCDIR)lib/sdbm/sdbm_hash.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/sdbm/sdbm_hash.c

################ djgpp

osinit.o: $(SRCDIR)lib/djgpp/osinit.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/djgpp/osinit.c

sys.o:	$(SRCDIR)lib/djgpp/sys.c
	$(CC) $(CFLAGS) $(SRCDIR)lib/djgpp/sys.c

################################################################

install: always
	config/install.bat djgpp \snobol4

always:

=== pkg/solaris/Makefile ===
BASE=../..
pkg:	clean
	mkdir CSNOBOL4 REL
	cp $(BASE)/COPYRIGHT CSNOBOL4/copyright
	cp pkginfo prototype CSNOBOL4
	mkdir -p CSNOBOL4/lib/snobol4 CSNOBOL4/bin CSNOBOL4/man/man1
	cp $(BASE)/snobol4 CSNOBOL4/bin
	cp $(BASE)/snolib/*.sno CSNOBOL4/lib/snobol4
	cp $(BASE)/doc/load.txt $(BASE)/host.sno CSNOBOL4/lib/snobol4
	cp $(BASE)/include/*.h CSNOBOL4/lib/snobol4
	cp $(BASE)/config.h $(BASE)/equ.h CSNOBOL4/lib/snobol4
	cp $(BASE)/doc/snobol4.1 CSNOBOL4/man/man1
	cd CSNOBOL4; pkgmk -o -r . -d ../REL
	pkgtrans -s REL CSNOBOL4.stream CSNOBOL4

clean:
	rm -rf CSNOBOL4 REL

=== pkg/debian/control ===
Source: csnobol4
Section: devel
Priority: optional
Maintainer: <snobol4@ultimate.com>
Standards-Version: 3.0.1

Package: csnobol4
Architecture: any
Depends: ${shlibs:Depends}
Description: Macro SNOBOL4 in C
A port of the original Macro implementation of SNOBOL4
with SPITBOL and SNOBOL4+ enhancements
